#ifndef COMMON_H
#define COMMON_H

#include <xsimple.h>

typedef struct { unsigned char r, g, b; } RGB;

extern unsigned long p_red[], p_green[], p_blue[];

extern unsigned char *dp;
extern unsigned int *idp;

#define DOPIXEL(red, green, blue, maxval) \
do { \
    unsigned long pixel; \
    if (maxval == 255) \
        pixel = GETPIXEL(red, green, blue); \
    else \
        pixel = p_red[red] | p_green[green] | p_blue[blue]; \
    *idp++ = pixel; \
} while (0)

#define DOPIXEL2(pixel) \
do { \
    *idp++ = pixel; \
} while (0)

#define ICC_CS_SIG_RGB  0x52474220
#define ICC_CS_SIG_CMYK 0x434d594b

#endif
